<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>AVM2: </title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.7.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul class="tablist">
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<p><a name="lookupswitch"></a></p>
<h2><a class="anchor" id="lookupswitch"></a>
lookupswitch</h2>
<h3><a class="anchor" id="operation"></a>
Operation</h3>
<p>Jump to different locations based on an index.</p>
<h3><a class="anchor" id="format"></a>
Format</h3>
<div class="fragment"><pre class="fragment">lookupswitch
default_offset 
case_count 
case_offsets...
</pre></div><h3><a class="anchor" id="forms"></a>
Forms</h3>
<div class="fragment"><pre class="fragment">lookupswitch = 27(0x1b)
</pre></div> <h3><a class="anchor" id="stack"></a>
Stack</h3>
<div class="fragment"><pre class="fragment">..., index =&gt; ...
</pre></div><h3><a class="anchor" id="description"></a>
Description</h3>
<p>default_offset is an s24 that is the offset to jump, in bytes, for the default case. case_offsets are each an s24 that is the offset to jump for a particular index. There are case_count+1 case offsets. case_count is a u30.</p>
<p>index is popped off of the stack and must be of type int. If index is less than zero or greater than case_count, the target is calculated by adding default_offset to the base location. Otherwise the target is calculated by adding the case_offset at position index to the base location. Execution continues from the target location.</p>
<p>The base location is the address of the lookupswitch instruction itself.</p>
<h3><a class="anchor" id="rt_execeptions"></a>
Runtime exceptions</h3>
<p>None.</p>
<h3><a class="anchor" id="notes"></a>
Notes</h3>
<p>Other control flow instructions take the base location to be the address of the following instruction. </p>
</div>
<hr class="footer"/><address class="footer"><small>Generated on Thu Jan 6 2011 10:19:15 for AVM2 by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.7.1 </small></address>
</body>
</html>
